﻿

XIncludeFile "ENM_SimpleRPC.pbi"

InitNetwork()

Procedure.s Mem2Base64_c(*Mem, MemSize)
  Protected *BaseMem, BaseMemSize, Base64$
  If MemSize*2>=64
    BaseMemSize = MemSize*2
  Else
    BaseMemSize = 64
  EndIf
  *BaseMem = AllocateMemory(BaseMemSize)
  BaseMemSize = Base64Encoder(*Mem, MemSize, *BaseMem, BaseMemSize)
  Base64$ = PeekS(*BaseMem, BaseMemSize)
  FreeMemory(*BaseMem)
  ProcedureReturn Base64$
EndProcedure

Procedure Base642Mem_c(Base64$, *Mem, MemSize)
  ProcedureReturn Base64Decoder(@Base64$, StringByteLength(Base64$), *Mem, MemSize)
EndProcedure

; Daten für Serial-Port Hook
Structure _SPRPC_Data
  SPortID.l
  RPCClient.ENM_RPC_Client
  AvailableSerialPortInput.ENM_RPC_Procedure_l
  AvailableSerialPortOutput.ENM_RPC_Procedure_l
  CloseSerialPort.ENM_RPC_Procedure_l
  GetSerialPortStatus.ENM_RPC_Procedure_l
  IsSerialPort.ENM_RPC_Procedure_l
  OpenSerialPort.ENM_RPC_Procedure_q
  ReadSerialPortData.ENM_RPC_Procedure_s
  SerialPortError.ENM_RPC_Procedure_l
  SerialPortID.ENM_RPC_Procedure_l
  SerialPortTimeouts.ENM_RPC_Procedure_l
  SetSerialPortStatus.ENM_RPC_Procedure_l
  WriteSerialPortData.ENM_RPC_Procedure_l
  WriteSerialPortString.ENM_RPC_Procedure_l
EndStructure

; SerialPort HookHandler
Global NewMap *__SPortHandler._SPRPC_Data()

Procedure _OpenSerialPort(SerialPort, SerialPortName$, Bauds, Parity, _Data, Stop, HandshakeMode, InputBufferSize, OutputBufferSize, RemoteServer$ = "", RemoteServerPort = #Null)
  Protected *SPRPC._SPRPC_Data = AllocateMemory(SizeOf(_SPRPC_Data)), SP
  
  If RemoteServer$ ; Remote-Verbindung
    *SPRPC\RPCClient = ENM_RPC_NewClient(RemoteServer$, RemoteServerPort)
    If *SPRPC\RPCClient
      ; Proceduren verbinden:
      *SPRPC\OpenSerialPort = *SPRPC\RPCClient\ConnectProcedure("OpenSerialPort", #PB_Quad)
      If *SPRPC\OpenSerialPort
        Protected p.ENM_RPC_Parameter
        AddElement(p\p()) : p\p()\Type = #PB_Quad : p\p()\q = SerialPort
        AddElement(p\p()) : p\p()\Type = #PB_String : p\p()\s = SerialPortName$
        AddElement(p\p()) : p\p()\Type = #PB_Long : p\p()\l = Bauds
        AddElement(p\p()) : p\p()\Type = #PB_Long : p\p()\l = Parity
        AddElement(p\p()) : p\p()\Type = #PB_Long : p\p()\l = _Data
        AddElement(p\p()) : p\p()\Type = #PB_Long : p\p()\l = Stop
        AddElement(p\p()) : p\p()\Type = #PB_Long : p\p()\l = HandshakeMode
        AddElement(p\p()) : p\p()\Type = #PB_Long : p\p()\l = InputBufferSize
        AddElement(p\p()) : p\p()\Type = #PB_Long : p\p()\l = OutputBufferSize
        SP = *SPRPC\OpenSerialPort\Call(p)
        If SP ; Alles Ok, Rest öffnen und eintragen
          ; Eintragen
          If SerialPort <> #PB_Any
            *SPRPC\SPortID = SerialPort
          Else
            *SPRPC\SPortID = SP
          EndIf
          AddMapElement(*__SPortHandler(), Str(*SPRPC\SPortID))
          *__SPortHandler() = *SPRPC
          
          With *SPRPC
            \AvailableSerialPortInput = \RPCClient\ConnectProcedure("AvailableSerialPortInput", #PB_Long)
            \AvailableSerialPortOutput = \RPCClient\ConnectProcedure("AvailableSerialPortOutput", #PB_Long)
            \CloseSerialPort = \RPCClient\ConnectProcedure("CloseSerialPort", #PB_Long)
            \GetSerialPortStatus = \RPCClient\ConnectProcedure("GetSerialPortStatus", #PB_Long)
            \IsSerialPort = \RPCClient\ConnectProcedure("IsSerialPort", #PB_Long)
            \ReadSerialPortData = \RPCClient\ConnectProcedure("ReadSerialPortDataBase64", #PB_String)
            \SerialPortError = \RPCClient\ConnectProcedure("SerialPortError", #PB_Long)
            \SerialPortID = \RPCClient\ConnectProcedure("SerialPortID", #PB_Long)
            \SerialPortTimeouts = \RPCClient\ConnectProcedure("SerialPortTimeouts", #PB_Long)
            \SetSerialPortStatus = \RPCClient\ConnectProcedure("SetSerialPortStatus", #PB_Long)
            \WriteSerialPortData = \RPCClient\ConnectProcedure("WriteSerialPortData", #PB_Long)
            \WriteSerialPortString = \RPCClient\ConnectProcedure("WriteSerialPortString", #PB_Long)
          EndWith
        Else
          *SPRPC\RPCClient\Free()
          *SPRPC\OpenSerialPort\Free()
          FreeMemory(*SPRPC)
          *SPRPC = #Null
        EndIf
      Else
        *SPRPC\RPCClient\Free()
        FreeMemory(*SPRPC)
        *SPRPC = #Null
      EndIf
    Else ; Konnte nicht verbinden
      FreeMemory(*SPRPC)
      *SPRPC = #Null
    EndIf
  Else ; Lokaler Port
    SP = OpenSerialPort(SerialPort, SerialPortName$, Bauds, Parity, _Data, Stop, HandshakeMode, InputBufferSize, OutputBufferSize)
    If SP
      If SerialPort <> #PB_Any
        *SPRPC\SPortID = SerialPort
      Else
        *SPRPC\SPortID = SP
      EndIf
      AddMapElement(*__SPortHandler(), Str(*SPRPC\SPortID))
      *__SPortHandler() = *SPRPC
    Else
      FreeMemory(*SPRPC)
      *SPRPC = #Null
    EndIf
  EndIf
  
  ProcedureReturn SP
EndProcedure


Macro _Macro
  Macro
EndMacro

Macro __SerialPortGetX(_Procedure)
  Procedure _#_Procedure(SerialPort)
    Protected *SPRPC._SPRPC_Data = FindMapElement(*__SPortHandler(), Str(SerialPort))
    Protected p.ENM_RPC_Parameter
    
    If *SPRPC
      *SPRPC = PeekI(*SPRPC)
      If *SPRPC\RPCClient ; Remote-Verbindung
        AddElement(p\p()) : p\p()\Type = #PB_Quad : p\p()\q = SerialPort
        ProcedureReturn *SPRPC\_Procedure\Call(p)
      Else ; Lokal ausführen
        ProcedureReturn _Procedure(SerialPort)
      EndIf
    EndIf
  EndProcedure
  
  ; Hook
  Macro  _Procedure(SerialPort)
    _#_Procedure(SerialPort)
  :End#_Macro
EndMacro

Procedure _WriteSerialPortData(SerialPort, *Mem, MemSize)
  Protected *SPRPC._SPRPC_Data = FindMapElement(*__SPortHandler(), Str(SerialPort))
  Protected p.ENM_RPC_Parameter
  
  If *SPRPC
    *SPRPC = PeekI(*SPRPC)
    If *SPRPC\RPCClient ; Remote-Verbindung
      AddElement(p\p()) : p\p()\Type = #PB_Quad : p\p()\q = SerialPort
      AddElement(p\p()) : p\p()\Type = #PB_Long : p\p()\l = MemSize
      AddElement(p\p()) : p\p()\Type = #PB_String : p\p()\s = Mem2Base64_c(*Mem, MemSize)
      ProcedureReturn *SPRPC\WriteSerialPortData\Call(p)
    Else ; Lokal ausführen
      ProcedureReturn WriteSerialPortData(SerialPort, *Mem, MemSize)
    EndIf
  EndIf
EndProcedure

Procedure _WriteSerialPortString(SerialPort, String$)
  Protected *SPRPC._SPRPC_Data = FindMapElement(*__SPortHandler(), Str(SerialPort))
  Protected p.ENM_RPC_Parameter
  
  If *SPRPC
    *SPRPC = PeekI(*SPRPC)
    If *SPRPC\RPCClient ; Remote-Verbindung
      AddElement(p\p()) : p\p()\Type = #PB_Quad : p\p()\q = SerialPort
      AddElement(p\p()) : p\p()\Type = #PB_String : p\p()\s = String$
      ProcedureReturn *SPRPC\WriteSerialPortString\Call(p)
    Else ; Lokal ausführen
      ProcedureReturn WriteSerialPortString(SerialPort, String$)
    EndIf
  EndIf
EndProcedure

Procedure _ReadSerialPortData(SerialPort, *Mem, MemSize)
  Protected *SPRPC._SPRPC_Data = FindMapElement(*__SPortHandler(), Str(SerialPort))
  Protected p.ENM_RPC_Parameter, Base64$
  
  
  If *SPRPC
    *SPRPC = PeekI(*SPRPC)
    If *SPRPC\RPCClient ; Remote-Verbindung
      AddElement(p\p()) : p\p()\Type = #PB_Quad : p\p()\q = SerialPort
      AddElement(p\p()) : p\p()\Type = #PB_Long : p\p()\l = MemSize
      Base64$ = *SPRPC\ReadSerialPortData\Call(p)
      ; Base64 in Speicher umlegen
      ProcedureReturn Base642Mem_c(Base64$, *Mem, MemSize)
    Else ; Lokal ausführen
      ProcedureReturn ReadSerialPortData(SerialPort, *Mem, MemSize)
    EndIf
  EndIf
EndProcedure


Procedure _GetSerialPortStatus(SerialPort, Attribute)
  Protected *SPRPC._SPRPC_Data = FindMapElement(*__SPortHandler(), Str(SerialPort))
  Protected p.ENM_RPC_Parameter
  
  If *SPRPC
    *SPRPC = PeekI(*SPRPC)
    If *SPRPC\RPCClient ; Remote-Verbindung
      AddElement(p\p()) : p\p()\Type = #PB_Quad : p\p()\q = SerialPort
      AddElement(p\p()) : p\p()\Type = #PB_Long : p\p()\l = Attribute
      ProcedureReturn *SPRPC\GetSerialPortStatus\Call(p)
    Else ; Lokal ausführen
      ProcedureReturn GetSerialPortStatus(SerialPort, Attribute)
    EndIf
  EndIf
EndProcedure

Procedure _SetSerialPortStatus(SerialPort, Attribute, Value)
  Protected *SPRPC._SPRPC_Data = FindMapElement(*__SPortHandler(), Str(SerialPort))
  Protected p.ENM_RPC_Parameter
  
  If *SPRPC
    *SPRPC = PeekI(*SPRPC)
    If *SPRPC\RPCClient ; Remote-Verbindung
      AddElement(p\p()) : p\p()\Type = #PB_Quad : p\p()\q = SerialPort
      AddElement(p\p()) : p\p()\Type = #PB_Long : p\p()\l = Attribute
      AddElement(p\p()) : p\p()\Type = #PB_Long : p\p()\l = Value
      ProcedureReturn *SPRPC\SetSerialPortStatus\Call(p)
    Else ; Lokal ausführen
      ProcedureReturn SetSerialPortStatus(SerialPort, Attribute, Value)
    EndIf
  EndIf
EndProcedure

Procedure _SerialPortTimeouts(SerialPort, t1, t2, t3, t4, t5)
  Protected *SPRPC._SPRPC_Data = FindMapElement(*__SPortHandler(), Str(SerialPort))
  Protected p.ENM_RPC_Parameter
  
  If *SPRPC
    *SPRPC = PeekI(*SPRPC)
    If *SPRPC\RPCClient ; Remote-Verbindung
      AddElement(p\p()) : p\p()\Type = #PB_Quad : p\p()\q = SerialPort
      AddElement(p\p()) : p\p()\Type = #PB_Long : p\p()\l = t1
      AddElement(p\p()) : p\p()\Type = #PB_Long : p\p()\l = t2
      AddElement(p\p()) : p\p()\Type = #PB_Long : p\p()\l = t3
      AddElement(p\p()) : p\p()\Type = #PB_Long : p\p()\l = t4
      AddElement(p\p()) : p\p()\Type = #PB_Long : p\p()\l = t5
      ProcedureReturn *SPRPC\SerialPortTimeouts\Call(p)
    Else ; Lokal ausführen
      ProcedureReturn SerialPortTimeouts(SerialPort, t1, t2, t3, t4, t5)
    EndIf
  EndIf
EndProcedure

Procedure _CloseSerialPort(SerialPort)
  Protected *SPRPC._SPRPC_Data = FindMapElement(*__SPortHandler(), Str(SerialPort))
  Protected p.ENM_RPC_Parameter
  Protected rtVar
  
  If *SPRPC
    *SPRPC = PeekI(*SPRPC)
    ; Austragen
    DeleteMapElement(*__SPortHandler(), Str(SerialPort))
    If *SPRPC\RPCClient ; Remote-Verbindung
      AddElement(p\p()) : p\p()\Type = #PB_Quad : p\p()\q = SerialPort
      rtVar = *SPRPC\CloseSerialPort\Call(p)
      ; Alles freigeben
      With *SPRPC
        \RPCClient\Free()
        \OpenSerialPort\Free()
        \AvailableSerialPortInput\Free()
        \AvailableSerialPortOutput\Free()
        \CloseSerialPort\Free()
        \GetSerialPortStatus\Free()
        \IsSerialPort\Free()
        \ReadSerialPortData\Free()
        \SerialPortError\Free()
        \SerialPortID\Free()
        \SerialPortTimeouts\Free()
        \SetSerialPortStatus\Free()
        \WriteSerialPortData\Free()
        \WriteSerialPortString\Free()
        FreeMemory(*SPRPC)
      EndWith
      ProcedureReturn rtVar
    Else ; Lokal ausführen
      ProcedureReturn CloseSerialPort(SerialPort)
    EndIf
  EndIf
EndProcedure
  
  
; Einfache get-Routinen
__SerialPortGetX(AvailableSerialPortInput)
__SerialPortGetX(AvailableSerialPortOutput)
__SerialPortGetX(IsSerialPort)
__SerialPortGetX(SerialPortError)
__SerialPortGetX(SerialPortID)

; Rest-Hook

Macro OpenSerialPort(SerialPort, SerialPortName, Bauds, Parity, _Data, Stop, HandshakeMode, InputBufferSize, OutputBufferSize, RemoteServer = "", RemoteServerPort = #Null)
  _OpenSerialPort(SerialPort, SerialPortName, Bauds, Parity, _Data, Stop, HandshakeMode, InputBufferSize, OutputBufferSize, RemoteServer, RemoteServerPort)  
EndMacro

Macro CloseSerialPort(SerialPort)
  _CloseSerialPort(SerialPort)
EndMacro

Macro WriteSerialPortData(SerialPort, Mem, MemSize)
  _WriteSerialPortData(SerialPort, Mem, MemSize)
EndMacro

Macro WriteSerialPortString(SerialPort, String)
  _WriteSerialPortString(SerialPort, String)
EndMacro

Macro ReadSerialPortData(SerialPort, Mem, MemSize)
  _ReadSerialPortData(SerialPort, Mem, MemSize)
EndMacro

Macro GetSerialPortStatus(SerialPort, Attribute)
  _GetSerialPortStatus(SerialPort, Attribute)
EndMacro

Macro SetSerialPortStatus(SerialPort, Attribute, Value)
  _SetSerialPortStatus(SerialPort, Attribute, Value)
EndMacro

Macro SerialPortTimeouts(SerialPort, t1, t2, t3, t4, t5)
  _SerialPortTimeouts(SerialPort, t1, t2, t3, t4, t5)
EndMacro

; IDE Options = PureBasic 4.60 Beta 3 (Windows - x64)
; CursorPosition = 325
; Folding = ----
; EnableThread
; EnableXP
; CPU = 1
; Compiler = PureBasic 4.60 Beta 3 (Windows - x86)