﻿
; SimpleRPC einbinden...
XIncludeFile "ENM_SimpleRPC.pbi"

Procedure.s Mem2Base64(*Mem, MemSize)
  Protected *BaseMem, BaseMemSize, Base64$
  If MemSize*2>=64
    BaseMemSize = MemSize*2
  Else
    BaseMemSize = 64
  EndIf
  *BaseMem = AllocateMemory(BaseMemSize)
  BaseMemSize = Base64Encoder(*Mem, MemSize, *BaseMem, BaseMemSize)
  Base64$ = PeekS(*BaseMem, BaseMemSize)
  FreeMemory(*BaseMem)
  ProcedureReturn Base64$
EndProcedure

Procedure Base642Mem(Base64$, *Mem, MemSize)
  ProcedureReturn Base64Decoder(@Base64$, StringByteLength(Base64$), *Mem, MemSize)
EndProcedure

Procedure.l _R_AvailableSerialPortInput(*p.ENM_RPC_Parameter)
  ProcedureReturn AvailableSerialPortInput(*p\p()\q)
EndProcedure

Procedure.l _R_AvailableSerialPortOutput(*p.ENM_RPC_Parameter)
  ProcedureReturn AvailableSerialPortOutput(*p\p()\q)
EndProcedure

Procedure.l _R_CloseSerialPort(*p.ENM_RPC_Parameter)
  ProcedureReturn CloseSerialPort(*p\p()\q)
EndProcedure

Procedure.l _R_GetSerialPortStatus(*p.ENM_RPC_Parameter)
  Protected SerialPort.q = *p\p()\q : NextElement(*p\p())
  Protected Attributes = *p\p()\l
  ProcedureReturn GetSerialPortStatus(SerialPort, Attributes)
EndProcedure

Procedure.l _R_IsSerialPort(*p.ENM_RPC_Parameter)
  ProcedureReturn IsSerialPort(*p\p()\q)
EndProcedure

Procedure.q _R_OpenSerialPort(*p.ENM_RPC_Parameter)
  Protected SerialPort.l, SerialPortName$, Baud.l, Parity.l, _Data.l, Stop.l, HandshakeMod.l, InputBufferSize.l, OutputBufferSize.l
  SerialPort = *p\p()\l : NextElement(*p\p())
  SerialPortName$ = *p\p()\s : NextElement(*p\p())
  Baud = *p\p()\l : NextElement(*p\p())
  Parity = *p\p()\l : NextElement(*p\p())
  _Data = *p\p()\l : NextElement(*p\p())
  Stop = *p\p()\l : NextElement(*p\p())
  HandshakeMod = *p\p()\l : NextElement(*p\p())
  InputBufferSize = *p\p()\l : NextElement(*p\p())
  OutputBufferSize = *p\p()\l
  ProcedureReturn OpenSerialPort(SerialPort, SerialPortName$, Baud, Parity, _Data, Stop, HandshakeMod, InputBufferSize, OutputBufferSize)
EndProcedure

Procedure.s _R_ReadSerialPortDataBase64(*p.ENM_RPC_Parameter)
  Protected SerialPort.q, *Mem, MemSize.l, Base64$
  SerialPort = *p\p()\q : NextElement(*p\p())
  MemSize = *p\p()\l
  *Mem = AllocateMemory(MemSize)
  MemSize = ReadSerialPortData(SerialPort, *Mem, MemSize)
  
  Base64$ = Mem2Base64(*Mem, MemSize)
  FreeMemory(*Mem)
  
  ProcedureReturn Base64$
EndProcedure

Procedure.l _R_SerialPortError(*p.ENM_RPC_Parameter)
  ProcedureReturn SerialPortError(*p\p()\q)
EndProcedure

Procedure.l _R_SerialPortID(*p.ENM_RPC_Parameter)
  ProcedureReturn SerialPortID(*p\p()\q)
EndProcedure

Procedure.l _R_SerialPortTimeouts(*p.ENM_RPC_Parameter)
  Protected SerialPort.q, t1.l, t2.l, t3.l, t4.l, t5.l
  SerialPort = *p\p()\q : NextElement(*p\p())
  t1 = *p\p()\l : NextElement(*p\p())
  t2 = *p\p()\l : NextElement(*p\p())
  t3 = *p\p()\l : NextElement(*p\p())
  t4 = *p\p()\l : NextElement(*p\p())
  t5 = *p\p()\l
  ProcedureReturn SerialPortTimeouts(SerialPort, t1, t2, t3, t4, t5)
EndProcedure

Procedure.l _R_SetSerialPortStatus(*p.ENM_RPC_Parameter)
  Protected SerialPort.q, t1.l, t2.l
  SerialPort = *p\p()\q : NextElement(*p\p())
  t1 = *p\p()\l : NextElement(*p\p())
  t2 = *p\p()\l
  ProcedureReturn SetSerialPortStatus(SerialPort, t1, t2)
EndProcedure

Procedure.l _R_WriteSerialPortData(*p.ENM_RPC_Parameter)
  Protected SerialPort.q, MemSize.l, *Mem, Base64$, RtVar.l
  SerialPort = *p\p()\q : NextElement(*p\p())
  MemSize = *p\p()\l : NextElement(*p\p())
  Base64$ = *p\p()\s
  *Mem = AllocateMemory(MemSize)
  Base642Mem(Base64$, *Mem, MemSize)
  RtVar.l = WriteSerialPortData(SerialPort, *Mem, MemSize)
  FreeMemory(*Mem)
  ProcedureReturn RtVar
EndProcedure

Procedure.l _R_WriteSerialPortString(*p.ENM_RPC_Parameter)
  Protected SerialPort.q, String$, Format.l
  SerialPort = *p\p()\q : NextElement(*p\p())
  String$ = *p\p()\s  : NextElement(*p\p())
  Format = *p\p()\l  : NextElement(*p\p())
  ProcedureReturn WriteSerialPortString(SerialPort, String$, Format)
EndProcedure

; eigentlicher Server

InitNetwork()

; Server erstellen
Define RPC.ENM_RPC_Server = ENM_RPC_NewServer(1024)

; Proceduren hinzufügen ...
RPC\AddProcedure("AvailableSerialPortInput", #PB_Long, @_R_AvailableSerialPortInput())
RPC\AddProcedure("AvailableSerialPortOutput", #PB_Long, @_R_AvailableSerialPortOutput())
RPC\AddProcedure("CloseSerialPort", #PB_Long, @_R_CloseSerialPort())
RPC\AddProcedure("GetSerialPortStatus", #PB_Long, @_R_GetSerialPortStatus())
RPC\AddProcedure("IsSerialPort", #PB_Long, @_R_IsSerialPort())
RPC\AddProcedure("OpenSerialPort", #PB_Quad, @_R_OpenSerialPort())
RPC\AddProcedure("ReadSerialPortDataBase64", #PB_String, @_R_ReadSerialPortDataBase64())
RPC\AddProcedure("SerialPortError", #PB_Long, @_R_SerialPortError())
RPC\AddProcedure("SerialPortID", #PB_Long, @_R_SerialPortID())
RPC\AddProcedure("SerialPortTimeouts", #PB_Long, @_R_SerialPortTimeouts())
RPC\AddProcedure("SetSerialPortStatus", #PB_Long, @_R_SetSerialPortStatus())
RPC\AddProcedure("WriteSerialPortData", #PB_Long, @_R_WriteSerialPortData())
RPC\AddProcedure("WriteSerialPortString", #PB_Long, @_R_WriteSerialPortString())

OpenConsole()
ConsoleTitle("Serial Port Server")
Print("Press any key to exit Serial Port Server... ")
Input()
CloseConsole()

; Server beenden
RPC\Free()
; IDE Options = PureBasic 4.60 Beta 3 (Windows - x64)
; CursorPosition = 127
; FirstLine = 108
; Folding = ---
; EnableThread
; EnableXP
; CPU = 1
; Compiler = PureBasic 4.60 Beta 3 (Windows - x86)