; ------------------------------------------------------------------------------------
; FastMemory ASM Wrapper
; PB: 4.3 +
; Windows/Linux/MacOs x86/x64
; ------------------------------------------------------------------------------------

; ------------------------------------------------------------------------------------
; Internal
; ------------------------------------------------------------------------------------

; Auf True setzen wenn Move nicht gebraucht wird (spart ~5KB)
#NoMove = #True

CompilerSelect #PB_Compiler_OS
    
  CompilerCase #PB_OS_Windows
    CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
      ImportC "Common\libs\alibcof64.lib"
        A_memcpy(*dest, *source, count.i)
        CompilerIf #NoMove = #False
          A_memmove(*dest, *source, count.i)
        CompilerEndIf
        InstructionSet()
      EndImport
      
    CompilerElse ;x86
      ImportC "Common\libs\alibcof32.lib"
        A_memcpy(*dest, *source, count.i)
        CompilerIf #NoMove = #False
          A_memmove(*dest, *source, count.i)
        CompilerEndIf
        InstructionSet()
      EndImport
      
    CompilerEndIf
    
  CompilerCase #PB_OS_Linux
    CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
      ImportC "Common/libs/alibelf64.a"
        A_memcpy(*dest, *source, count.i)
        CompilerIf #NoMove = #False
          A_memmove(*dest, *source, count.i)
        CompilerEndIf
        InstructionSet()
      EndImport
      
    CompilerElse ;x86
      ImportC "Common/libs/alibelf32.a"
        A_memcpy(*dest, *source, count.i)
        CompilerIf #NoMove = #False
          A_memmove(*dest, *source, count.i)
        CompilerEndIf
        InstructionSet()
      EndImport
      
    CompilerEndIf
    
  CompilerCase #PB_OS_MacOS
    CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
      ImportC "Common/libs/alibmac64.a"
        A_memcpy(*dest, *source, count.i)
        CompilerIf #NoMove = #False
          A_memmove(*dest, *source, count.i)
        CompilerEndIf
        InstructionSet()
      EndImport
      
    CompilerElse ;x86
      ImportC "Common/libs/alibmac32.a"
        A_memcpy(*dest, *source, count.i)
        CompilerIf #NoMove = #False
          A_memmove(*dest, *source, count.i)
        CompilerEndIf
        InstructionSet()
      EndImport
      
    CompilerEndIf
CompilerEndSelect
PrototypeC FastMem_MemFunc(Destination, Source, Size)

ProcedureC FastMem_Wrapper_Copy(Destination, Source, Size)
  CopyMemory(Source, Destination, Size)
EndProcedure

CompilerIf #NoMove = #False
  ProcedureC FastMem_Wrapper_Move(Destination, Source, Size)
    MoveMemory(Source, Destination, Size)
  EndProcedure
CompilerEndIf

Global _FastMem_Copy.FastMem_MemFunc

CompilerIf #NoMove = #False
  Global _FastMem_Move.FastMem_MemFunc
CompilerEndIf

Macro FastMem_Init()
  If InstructionSet()> = 3 ; SSE Mindestanforderung
    _FastMem_Copy = @A_memcpy()
    CompilerIf #NoMove = #False
      _FastMem_Move = @A_memmove()
    CompilerEndIf
  Else
    _FastMem_Copy = @FastMem_Wrapper_Copy()
    CompilerIf #NoMove = #False
      _FastMem_Move = @FastMem_Wrapper_Move()
    CompilerEndIf
  EndIf
EndMacro : FastMem_Init()

; ------------------------------------------------------------------------------------
; Public
; ------------------------------------------------------------------------------------

Macro CopyMemory(Source, Destination, Size)
  _FastMem_Copy(Destination, Source, Size)
EndMacro

CompilerIf #NoMove = #False
  Macro MoveMemory(Source, Dest, Size)
    _FastMem_Move(Destination, Source, Size)
  EndMacro
CompilerEndIf









; IDE Options = PureBasic 4.51 (Windows - x64)
; CursorPosition = 89
; FirstLine = 50
; Folding = -
; EnableXP
; CPU = 1
; DisableDebugger