﻿; ------------------------------------------------------------------------------------
; Ping und DNS-Lockup
; (c) Alexander Aigner
; PB 4.5 + / x86 + x64 / Ascii + Unicode
; Windows - Only! [API]
; ------------------------------------------------------------------------------------

CompilerIf #PB_Compiler_OS = #PB_OS_Windows
  
  Procedure DNSLockup(ServerName.s)
    Protected *HostInfo.HOSTENT, ServerIP
    CompilerIf #PB_Compiler_Unicode = #True
      Protected AsciiBuffer$ = Space(Len(ServerName))
      PokeS(@AsciiBuffer$, ServerName, Len(ServerName), #PB_Ascii)
      *HostInfo = gethostbyname_(@AsciiBuffer$)
    CompilerElse
      *HostInfo = gethostbyname_(@ServerName)
    CompilerEndIf
    If *HostInfo
      ServerIP = MakeIPAddress(PeekB(PeekL(*HostInfo\h_addr_list)), PeekB(PeekL(*HostInfo\h_addr_list)+1), PeekB(PeekL(*HostInfo\h_addr_list)+2), PeekB(PeekL(*HostInfo\h_addr_list)+3))
    EndIf
    
    ProcedureReturn ServerIP
  EndProcedure
  
  Procedure Ping(IP.s, TimeOUT)
    Protected lngHPort, strMessage.s, MsgLen, lngDAddress
    Protected *ECHO.ICMP_ECHO_REPLY, Result = -1
    
    lngDAddress = DNSLockup(IP)
    If lngDAddress
      lngHPort = IcmpCreateFile_()
      If lngHPort <> #INVALID_HANDLE_VALUE
        strMessage  = "ENM Echo this Message back to me"
        MsgLen      = StringByteLength(strMessage)
        *ECHO       = AllocateMemory(SizeOf(ICMP_ECHO_REPLY) + MsgLen + 16)
        
        If IcmpSendEcho_(lngHPort, lngDAddress, @strMessage, MsgLen, #Null, *ECHO, SizeOf(ICMP_ECHO_REPLY) + MsgLen + 16, TimeOUT)
          Result = *ECHO\RoundTripTime
        EndIf
        FreeMemory(*ECHO)
        IcmpCloseHandle_(lngHPort)
      EndIf
    EndIf
    
    ProcedureReturn Result
  EndProcedure
  
CompilerElse
  
  Macro DNSLockup(ServerName)
    #Null  
  EndMacro
  
  Macro Ping(IP, TimeOut)
    #Null  
  EndMacro
  
CompilerEndIf

; IDE Options = PureBasic 4.60 Beta 3 (Windows - x64)
; CursorPosition = 11
; Folding = -
; EnableXP
; CPU = 1