; ------------------------------------------------------------------------------------
; Dynamischer Stack
; Author: Alexander Aigner
; PB 4.3+ x86/x64
; ------------------------------------------------------------------------------------

;EnableExplicit

Structure tStackItem
  Val.i
  *Previous
EndStructure

Structure tStack
  *Current.tStackItem
  Cnt.i
  *Last.tStackItem
EndStructure

Procedure Stack_New()
  Protected *Stack.tStack = AllocateMemory(SizeOf(tStack))
  ProcedureReturn *Stack
EndProcedure

Procedure Stack_PushF(*Stack.tStack, Val.i)
  Protected *NewItem .tStackItem
  
  If Not *Stack\Current
    *Stack\Current = AllocateMemory(SizeOf(tStackItem))
    *Stack\Current\Val = Val
    *Stack\Cnt + 1
    *Stack\Last = *Stack\Current
    ProcedureReturn #True
  EndIf
  
  *NewItem = AllocateMemory(SizeOf(tStackItem))
  
  *Stack\Last\Previous = *NewItem
  *Stack\Last = *NewItem
  
  *Stack\Last\Val = Val
  *Stack\Cnt + 1
  
  ProcedureReturn #True
EndProcedure

Procedure Stack_Push(*Stack.tStack, Val)
  Protected *NewItem .tStackItem
  
  If Not *Stack\Current
    *Stack\Current = AllocateMemory(SizeOf(tStackItem))
    *Stack\Current\Val = Val
    *Stack\Cnt + 1
    *Stack\Last = *Stack\Current
    ProcedureReturn #True
  EndIf
  
  *NewItem = AllocateMemory(SizeOf(tStackItem))
  
  *NewItem\Previous = *Stack\Current
  *Stack\Current = *NewItem
  
  *Stack\Current\Val = Val
  *Stack\Cnt + 1
  ProcedureReturn #True
EndProcedure

Procedure Stack_Pop(*Stack.tStack)
  Protected Temp.i
  Protected *Previous
  
  *Previous = *Stack\Current\Previous
  Temp = *Stack\Current\Val
  
  FreeMemory(*Stack\Current)
  
  *Stack\Current = *Previous
  *Stack\Cnt-1
  
  ProcedureReturn Temp
EndProcedure

Procedure Stack_Free(*Stack.tStack)
  
  While *Stack\Current
    Stack_Pop(*Stack)
  Wend
  
  FreeMemory(*Stack)
  ProcedureReturn #False
EndProcedure

Macro Stack_Count(_Stack)
  _Stack#\Cnt
EndMacro

; DisableExplicit
; IDE Options = PureBasic 4.51 (Windows - x64)
; CursorPosition = 80
; FirstLine = 57
; Folding = --
; EnableXP
; CPU = 1