﻿; ------------------------------------------------------------------------------------
; Thread Std - Funktionen
; PB 4.5+ OS: Windows/Linux/MacOS Architecture: x86/x64
; Author: Alexander Aigner, cxAlex @ purebasic.fr/german
; Standart Funktionen und Strukturen für den Umgang mit Threads
; ------------------------------------------------------------------------------------

; Std - Threadverwaltung
Structure _Thread_Std
  GMutex.i ; Globale Schutzmutex für Thread ressourcen
  Stop.i ; Stop - Signal
  ID.i ; ThreadID
  Stoped.a ; Ist der Thread schon gestopt?
EndStructure

; Thread stoppen
Macro Thread_Std_Stop(_Thread)
  If Not _Thread#\Stoped
    _Thread#\Stop = CreateSemaphore()
    WaitSemaphore(_Thread#\Stop)
    FreeSemaphore(_Thread#\Stop)
    _Thread#\Stoped = #True
  EndIf
EndMacro

; Ist ein Stop-Signal da?
Macro Thread_Std_CheckStop(_Thread)
  If _Thread#\Stop ; StopSignal
    SignalSemaphore(_Thread#\Stop)
    ProcedureReturn #True
  EndIf
EndMacro

; Thread Deinitialisieren
Macro Thread_Std_DeInit(_Thread)
  If Not _Thread#\Stoped
    Thread_Std_Stop(_Thread)
  EndIf
  FreeMutex(_Thread#\GMutex)
EndMacro

; Thread stopen
Macro Thread_Std_Init(_Thread, _Procedure, _Para)
  _Thread#\GMutex = CreateMutex()
  _Thread\ID = CreateThread(@_Procedure, _Para)
EndMacro
; IDE Options = PureBasic 4.60 Beta 3 (Windows - x64)
; CursorPosition = 14
; FirstLine = 4
; Folding = -
; EnableXP
; CPU = 1