﻿; ------------------------------------------------------------------------------------
; Include: zlib - Packer
; minimale PB - Version: 4.3
; ------------------------------------------------------------------------------------

Structure zlib_Info
  DataOk.b
  MemSize.i
EndStructure

; Compilerweiche für die Librarys
CompilerSelect #PB_Compiler_OS
  CompilerCase #PB_OS_Windows : #zlib_ImportPath$ = "zlib.lib"
  CompilerCase #PB_OS_Linux   : #zlib_ImportPath$ = #PB_Compiler_Home + "purelibraries/linux/libraries/zlib.a"
  CompilerCase #PB_OS_MacOS   : #zlib_ImportPath$ = "/usr/lib/libz.dylib"      
CompilerEndSelect

ImportC #zlib_ImportPath$
  compress2(*dest, *destLen, *source, sourceLen, level)
  uncompress(*dest, *destLen, *source, sourceLen)
EndImport

Procedure zLib_compress(*Mem, MemSize, CompressionLevel, *Info.zlib_Info)
  Protected *PackedMem, PackedMemSize
  PackedMemSize = 13 + MemSize + MemSize/100
  *PackedMem = AllocateMemory(PackedMemSize)
  
  If Not compress2(*PackedMem, @PackedMemSize, *Mem, MemSize, CompressionLevel)
    If PackedMemSize >= MemSize ; Kompression unsinnig
      FreeMemory(*PackedMem)
      *PackedMem = #Null
      *Info\DataOk = #False 
    Else
      *PackedMem = ReAllocateMemory(*PackedMem, PackedMemSize)
      *Info\MemSize = PackedMemSize
      *Info\DataOk = #True
    EndIf
  Else
    FreeMemory(*PackedMem)
    *PackedMem = #Null
    *Info\DataOk = #False
  EndIf
  
  ProcedureReturn *PackedMem
EndProcedure

Procedure zLib_uncompress(*Mem, PackedSize, UnpackedMemSize)
  Protected *UnPackedMem = AllocateMemory(UnpackedMemSize)
  If Not uncompress(*UnPackedMem, @UnpackedMemSize, *Mem, PackedSize)
    ProcedureReturn *UnPackedMem
  Else
    FreeMemory(*UnPackedMem)
  EndIf
EndProcedure
; IDE Options = PureBasic 4.60 Beta 1 (Windows - x64)
; CursorPosition = 10
; Folding = -
; EnableXP
; CPU = 1