﻿; ------------------------------------------------------------------------------------
; Easy Network Manager - Logger Module - Reference Backend
; PB 4.5+ OS: Windows/Linux/MacOS Architecture: x86/x64
; Author: Alexander Aigner, cxAlex @ purebasic.fr/german
; ------------------------------------------------------------------------------------

; EnableExplicit

; Public Backend
CompilerIf Defined(ENM_Logger_Backend, #PB_Interface) = #False
  Interface ENM_Logger_Backend
    Free()  
  EndInterface
CompilerEndIf

; Interface
; Private Backend
CompilerIf Defined(_ENM_Logger_Backend_Private, #PB_Interface) = #False
  Interface _ENM_Logger_Backend_Private Extends ENM_Logger_Backend
    StartLogging()
    AddLogEntry(Caller$, LogLevel, LogTime, LogMessage$)
    StopLogging()
  EndInterface
CompilerEndIf

; Daten
CompilerIf Defined(_ENM_Logger_Backend_Data, #PB_Structure) = #False
  Structure _ENM_LoggerBackend_Data
    *VTable
    LoggerData.i
    ; Eigenes Verwaltungszeugs...
  EndStructure
CompilerEndIf

; Logger-Backend erstellen:
Procedure _ENM_LoggerBackend_NewReferenceLogger(LoggerData)
  Protected *ENMLB._ENM_LoggerBackend_Data = AllocateMemory(SizeOf(_ENM_LoggerBackend_Data))
  
  With *ENMLB
    \VTable = ?_ENM_LoggerBackend_VTable
    \LoggerData = LoggerData
  EndWith
  
  ProcedureReturn *ENMLB
EndProcedure

; Logger - Proceduren:

; Initialisieren
Procedure _ENM_LoggerBackend_StartLogging(*ENMLB._ENM_LoggerBackend_Data, LoggerData)
  With *ENMLB
    ; Initialisierungs-Zeug, 1. Eintrag schreiben,
    ; ev. Dateien öffnen, DB-Connections erstellen...
  EndWith
EndProcedure

Procedure _ENM_LoggerBackend_AddLogEntry(*ENMLB._ENM_LoggerBackend_Data, Caller$, LogLevel, LogTime, LogMessage$)
  With *ENMLB
    ; Eintrag in Datei, DB, ... schreiben.
  EndWith
EndProcedure

Procedure _ENM_LoggerBackend_StopLogging(*ENMLB._ENM_LoggerBackend_Data)
  With *ENMLB
    ; Letzten Eintrag schreiben, Log Ende
  EndWith
EndProcedure

Procedure _ENM_LoggerBackend_Free(*ENMLB._ENM_LoggerBackend_Data)
  With *ENMLB
    ; Dateien/DB schließen, Caches fluschen....
  EndWith
EndProcedure

; Data Section:
DataSection
  _ENM_LoggerBackend_VTable:
  Data.i @_ENM_LoggerBackend_Free()
  Data.i @_ENM_LoggerBackend_StartLogging()
  Data.i @_ENM_LoggerBackend_AddLogEntry()
  Data.i @_ENM_LoggerBackend_StopLogging()
EndDataSection
; IDE Options = PureBasic 4.60 Beta 3 (Windows - x64)
; CursorPosition = 80
; FirstLine = 42
; Folding = -
; EnableXP
; CPU = 1