﻿; ------------------------------------------------------------------------------------
; Easy Network Manager - Mistake Preventer
; PB 4.5+ OS: Windows/Linux/MacOS Architecture: x86/x64
; Author: Alexander Aigner, cxAlex @ purebasic.fr/german
; ------------------------------------------------------------------------------------

; verhindert Fehler beim Programmieren indem es Funktionen die man nicht zusammen mit
; ENM verwenden sollte abfängt und eine Fehlermeldung ausgibt

; Threadsafe muss aktiviert sein
CompilerIf #PB_Compiler_Thread = #Null
  CompilerError "Enable Thread-Safe!"
CompilerEndIf

CompilerIf #PB_Compiler_Version < 451
  CompilerError "Please use a supported PB - Version!"
CompilerEndIf
  

Global __Mistake

Macro OpenNetworkConnection(Server, Port, Type = #Null)
  __Mistake=__Mistake : CompilerError "Please use ENM\OpenConnection() !"
EndMacro

Macro CloseNetworkConnection(Connection)
  __Mistake=__Mistake : CompilerError "Please use ENM\CloseConnection() !"
EndMacro

Macro CreateNetworkServer(ServerID, Port, Type = #Null)
  __Mistake=__Mistake : CompilerError "Please use ENM\AddServer() !"
EndMacro

Macro CloseNetworkServer(ServerID)
  __Mistake=__Mistake : CompilerError "Please use ENM\RemoveServer() !"
EndMacro

Macro NetworkServerEvent()
  __Mistake=__Mistake : CompilerError "You don't need to use this function, it's internaly used by ENM !"
EndMacro

Macro NetworkClientEvent(Connection)
  __Mistake=__Mistake : CompilerError "You don't need to use this function, it's internaly used by ENM !"
EndMacro

Macro EventClient()
  __Mistake=__Mistake : CompilerError "You don't need to use this function, it's internaly used by ENM !"
EndMacro

Macro EventServer()
  __Mistake=__Mistake : CompilerError "You don't need to use this function, it's internaly used by ENM !"
EndMacro


; Prüft Einstellungen auf Plausibilität

Macro _DQ
  "
EndMacro

Macro _ENM_SettingsChecker_RangeCheck(_Const, _Min, _Max)
  CompilerIf (_Const < _Min) Or (_Const > _Max)
    CompilerError "Curious settings: " + _DQ#_Const#_DQ + " (Range: " + _DQ#_Min#_DQ + " - " + _DQ#_Max#_DQ + ")"
  CompilerEndIf
EndMacro

; Prüft die Einstellungen auf Plausibilität
Macro _ENM_SettingsChecker()
  _ENM_SettingsChecker_RangeCheck(#ENM_Sys_FalseEventFilter, #Null, 32)
  _ENM_SettingsChecker_RangeCheck(#ENM_Sys_FalseEventFilterDelay, #Null, 32)
  _ENM_SettingsChecker_RangeCheck(#ENM_Sys_NoEventDelay, 1, 32)
  _ENM_SettingsChecker_RangeCheck(#ENM_Sys_ReceiveLockDelay, #Null, 64)
  _ENM_SettingsChecker_RangeCheck(#ENM_Sys_ServerClientSlots, 512, 100*1024)
  _ENM_SettingsChecker_RangeCheck(#ENM_Sys_ConnectionSlots, 512, 100*1024)
  _ENM_SettingsChecker_RangeCheck(#ENM_Sys_UseFastMem, #False, #True)
  _ENM_SettingsChecker_RangeCheck(#ENM_Sys_UseMistakePreventer, #False, #True)
  _ENM_SettingsChecker_RangeCheck(#ENM_Sys_LimitClientConnections, #Null, 1000)
  _ENM_SettingsChecker_RangeCheck(#ENM_Sys_AsyncFree, #False, #True)
  _ENM_SettingsChecker_RangeCheck(#ENM_Sys_WindowsCloseConnectionWA, #False, #True)
  
  _ENM_SettingsChecker_RangeCheck(#ENM_SN_UDPWorkAround, #False, #True)
  _ENM_SettingsChecker_RangeCheck(#ENM_SN_UDPWorkAroundFakeConnect, #False, #True)
  _ENM_SettingsChecker_RangeCheck(#ENM_SN_UDPWorkAroundInactiveKill, 1000, 60*1000)
  _ENM_SettingsChecker_RangeCheck(#ENM_SN_UseVId, #False, #True)
  _ENM_SettingsChecker_RangeCheck(#ENM_SN_PingTimeout, -1, 10*1000)
  _ENM_SettingsChecker_RangeCheck(#ENM_SN_PingCacheTime, #Null, 60*1000)
  _ENM_SettingsChecker_RangeCheck(#ENM_SN_WSABlockDelay, #Null, 512)
  
  _ENM_SettingsChecker_RangeCheck(#ENM_JQ_SleepDelay, #Null, 2000)
  
  _ENM_SettingsChecker_RangeCheck(#ENM_Paket_MaxReloads, #Null, 30)
  _ENM_SettingsChecker_RangeCheck(#ENM_Paket_MaxResends, #Null, 30)
  _ENM_SettingsChecker_RangeCheck(#ENM_Paket_ReloadDelay, 0, 64)
  _ENM_SettingsChecker_RangeCheck(#ENM_Paket_ZeroReloadDelay, 1, 512)
  _ENM_SettingsChecker_RangeCheck(#ENM_Paket_DynamicReload, #False, #True)
  _ENM_SettingsChecker_RangeCheck(#ENM_Paket_MaxReloadDelayMultiplicator, #Null, #ENM_Paket_MaxReloads)
  _ENM_SettingsChecker_RangeCheck(#ENM_Paket_ReceiveBlockSize, 4*1024, 32*1024)
  
  _ENM_SettingsChecker_RangeCheck(#ENM_Stream_MaximumPartSize, 32*1024, 10*1024*1024)
  _ENM_SettingsChecker_RangeCheck(#ENM_Stream_BufferBlockSize, #ENM_Stream_MaximumPartSize, 25*#ENM_Stream_MaximumPartSize)
  
  _ENM_SettingsChecker_RangeCheck(#ENM_ProtoBP_MapSize, 2, 512)
  _ENM_SettingsChecker_RangeCheck(#ENM_ProtoT_DublicateBlueprint, #False, #True)
  
EndMacro : _ENM_SettingsChecker()


; IDE Options = PureBasic 4.60 Beta 3 (Windows - x64)
; CursorPosition = 84
; FirstLine = 67
; Folding = --
; EnableXP
; CPU = 1