﻿; ------------------------------------------------------------------------------------
; Easy Network Manager - Protokol Blueprint
; PB 4.5+ OS: Windows/Linux/MacOS Architecture: x86/x64
; Author: Alexander Aigner, cxAlex @ purebasic.fr/german
; ------------------------------------------------------------------------------------

; EnableExplicit

XIncludeFile "ENM_ProtocolCommons.pbi"

; BluePrint Structure in den Commons

; Kontroll - Interface
Interface ENM_Protocol_BluePrint
  Free()
EndInterface

; Kontroll - Interface (Intern)
Interface _ENM_Protocol_BluePrint_Ex Extends ENM_Protocol_BluePrint
  Dublicate() ; Dublizieren
  Lock() ; sperren
  Unlock() ; freigeben
EndInterface

; Neuer Blueprint
Procedure _ENM_Protocol_NewBlueprint(*ENM._ENM_Data, Blueprint$)
  Protected *ENMPBP._ENM_Protocol_Blueprint = AllocateMemory(SizeOf(_ENM_Protocol_Blueprint))
  InitializeStructure(*ENMPBP, _ENM_Protocol_Blueprint)
  
  If Not _ENM_Protocol_Parser(Blueprint$, *ENMPBP) ; Protokol Parsen
    ; Fehler: Alles freigeben
    ClearStructure(*ENMPBP, _ENM_Protocol_Blueprint)
    FreeMemory(*ENMPBP)
    *ENMPBP = #Null
  Else
    *ENMPBP\VTable = ?_ENM_Protocol_Blueprint_VTable ; VTable speichern
    *ENMPBP\ENM = *ENM
    *ENMPBP\cpyMutex = CreateMutex()
  EndIf
  
  ProcedureReturn *ENMPBP
EndProcedure

; Blueprint freigeben
Procedure _ENM_Protocol_Blueprint_Free(*ENMPBP._ENM_Protocol_Blueprint)
  With *ENMPBP
    FreeMutex(*ENMPBP\cpyMutex) ; Mutex freigeben
    ClearStructure(*ENMPBP, _ENM_Protocol_Blueprint)
    FreeMemory(*ENMPBP)
  EndWith
EndProcedure

CompilerIf #ENM_Sys_AsyncFree
  ; Procedure für den Async-Manager
  Procedure _ENM_Protocol_Blueprint_Free_Async(*ENMPD._ENM_Protocol_Default)
    With *ENMPD
      If ENM ; Haben wir eh noch kein DeInit?
        JQ_Add(\ENM\GBCollector, @_ENM_Protocol_Blueprint_Free(), *ENMPD)
      Else
        _ENM_Protocol_Blueprint_Free(*ENMPD) 
      EndIf
    EndWith
  EndProcedure
CompilerEndIf

; Blueprint dublizieren
Procedure _ENM_Protocol_Blueprint_Dublicate(*ENMPBP._ENM_Protocol_Blueprint)
  ; Neue Struktur anlegen
  Protected *ENMPBP_2._ENM_Protocol_Blueprint = AllocateMemory(SizeOf(_ENM_Protocol_Blueprint))
  InitializeStructure(*ENMPBP_2, _ENM_Protocol_Blueprint)
  
  ; Struktur kopieren
  LockMutex(*ENMPBP\cpyMutex) ; Muss gelockt werden, sonst Fehler möglich
  CopyStructure(*ENMPBP, *ENMPBP_2, _ENM_Protocol_Blueprint)
  UnlockMutex(*ENMPBP\cpyMutex)
  
    ; Eigene Mutex erzeugen:
  *ENMPBP_2\cpyMutex = CreateMutex()
  ProcedureReturn *ENMPBP_2
EndProcedure

; Blueprint sperren
Procedure _ENM_Protocol_Blueprint_Lock(*ENMPBP._ENM_Protocol_Blueprint)
  With *ENMPBP
    LockMutex(\cpyMutex) ; Mutex sperren
  EndWith
EndProcedure

; Blueprint entsperren
Procedure _ENM_Protocol_Blueprint_UnLock(*ENMPBP._ENM_Protocol_Blueprint)
  With *ENMPBP
    UnlockMutex(\cpyMutex) ; Mutex entsperren
  EndWith
EndProcedure

; VTable für den Blueprint
DataSection
  _ENM_Protocol_Blueprint_VTable:
  CompilerIf #ENM_Sys_AsyncFree
    Data.i @_ENM_Protocol_Blueprint_Free_Async()
  CompilerElse
    Data.i @_ENM_Protocol_Blueprint_Free()
  CompilerEndIf
  Data.i @_ENM_Protocol_Blueprint_Dublicate()
  Data.i @_ENM_Protocol_Blueprint_Lock()
  Data.i @_ENM_Protocol_Blueprint_UnLock()
EndDataSection

; IDE Options = PureBasic 4.60 Beta 3 (Windows - x64)
; CursorPosition = 59
; FirstLine = 39
; Folding = --
; EnableXP
; CPU = 1